/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Color;

/**
 *
 * @author Fabi
 */
public abstract class SideBlock extends Block {
    private static final float VELOCITY = 10;

    /**
     * @return the side
     */
    public Side getSide() {
        return side;
    }

    /**
     * @param side the side to set
     */
    public void setSide(Side side) {
        this.side = side;
    }

    public enum Side{
        UP,
        DOWN,
        RIGHT,
        LEFT
    }

    private Side side;

    @Override
    public void onCollision(GameObject o) {
        if (o instanceof Moveable) {
            Moveable m = (Moveable) o;
            switch (side){
                case UP:
                    m.setYVelocity(-VELOCITY);
                    break;
                case DOWN:
                    m.setYVelocity(VELOCITY);
                    break;
                case RIGHT:
                    m.setXVelocity(VELOCITY);
                    break;
                case LEFT:
                    m.setXVelocity(-VELOCITY);
                    break;
            }
            GameObject.eraseLater(this);
        }
    }

    @Override
    public void init() {
        super.init();
        setColor(Color.RED);
    }

}
