/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

/**
 *
 * @author Fabi
 */
public abstract class Application {

    protected abstract void init();

    protected abstract void start();

    protected abstract void exit();
    private static Application instance;

    public Application() {
        if (instance != null) {
            exitApplication();
        }
        instance = this;
        init();
    }

    public static void startApplication() {
        if (instance != null) {
            instance.start();
        }
    }

    public static void exitApplication() {
        if (instance != null) {
            instance.exit();
        }
        instance = null;
    }
}
