/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

/**
 *
 * @author Fabi
 */
public class ApplicationChooser extends JPanel implements ActionListener {

    private static final JFrame frame = new JFrame("ApplicationChooser");

    public ApplicationChooser() {
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        JButton gameButton = new JButton("Spiel starten");
        JButton levelButton = new JButton("Level bauen");
        JButton editButton = new JButton("Level laden");
        gameButton.setAlignmentX(CENTER_ALIGNMENT);
        levelButton.setAlignmentX(CENTER_ALIGNMENT);
        editButton.setAlignmentX(CENTER_ALIGNMENT);
        gameButton.setAlignmentY(CENTER_ALIGNMENT);
        levelButton.setAlignmentY(CENTER_ALIGNMENT);
        editButton.setAlignmentY(CENTER_ALIGNMENT);
        gameButton.setActionCommand("game");
        levelButton.setActionCommand("level");
        editButton.setActionCommand("edit");
        gameButton.addActionListener(this);
        levelButton.addActionListener(this);
        editButton.addActionListener(this);
        add(gameButton);
        add(levelButton);
        add(editButton);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {

            @Override
            public void run() {
                ApplicationChooser chooser = new ApplicationChooser();
                frame.add(chooser);
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                frame.pack();
                frame.setLocationByPlatform(true);
                frame.setResizable(false);
                frame.setVisible(true);
            }
        });
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        final String cmd = e.getActionCommand();
        if (cmd.equals("game")) {
            new GameStarter();
        } else if (cmd.equals("level")) {
            new LevelBuilder();
        } else if (cmd.equals("edit")){
            new EditLevelApplication();
        }
        Application.startApplication();
    }
}
