/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

/**
 *
 * @author Fabi
 */
public abstract class Block extends GameObject implements GameObject.CollisionListener {

    protected int cost;

    public Block(Point2D start, Point2D end) {
        setShape(new Rectangle2D.Double(start.getX(), start.getY(),
                Math.abs(
                start.getX() - end.getX()), Math.abs(
                start.getY() - end.getY())));
    }

    public Block(Rectangle2D rect) {
        setShape(rect);
    }

    public Block() {
        setShape(new Rectangle2D.Double());
    }

    public void setRectangle(Rectangle2D r) {
        setShape(r);
    }

    public Rectangle2D getRectangle() {
        return (getShape() instanceof Rectangle2D)
                ? (Rectangle2D) getShape() : null;
    }

    @Override
    public void updateObject() {
        GameObject.testCollision(this, this);
    }

    @Override
    public void init() {
    }
    
}
