/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package BallWar;
import static javax.swing.JOptionPane.*;

/**
 *
 * @author Fabi
 */
public class EditLevelApplication extends LevelBuilder{

    @Override
    protected void getLevelData() {
        if (!GameStarter.levelFile.exists()){
            showMessageDialog(null, "Fehler: Keine Level vorhanden!");
            exitApplication();
            return;
        }
        LevelList ll = LevelList.loadLevelList(GameStarter.levelFile);
        Level l = new LevelChooser(ll.getLevels()).getLevel();
        if (l == null){
            showMessageDialog(null, "Fehler: Kein Level ausgewählt!");
            exitApplication();
            return;
        }
        name = l.getName();
        size = l.getSize();
        minPoints = l.getMinPoints();
        for (GameObject obj : l){
            GameObject.addLater(obj);
        }
    }

}
