/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Graphics;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.plaf.ScrollBarUI;

/**
 *
 * @author Fabi
 */
public class GameScrollPane extends JScrollPane {    

    public GameScrollPane(final GamePanel panel) {
        super(panel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        // user can't change the scroll bar
        verticalScrollBar.setEnabled(false);
        // don't paint the scroll bar
        verticalScrollBar.setUI(new ScrollBarUI() {

            @Override
            public void paint(Graphics g, JComponent c) {
            }
        });
        verticalScrollBar.setMaximum(panel.getHeight());
        verticalScrollBar.setMinimum(0);
    }      
}
