/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package BallWar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

/**
 *
 * @author Fabi
 */
public class LevelChooser extends JDialog{

    private JPanel panel;
    private Level level;
    public LevelChooser(List<Level> levels) {
        setModal(true);
        setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        panel = new JPanel();
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
        for (final Level l : levels){
            JButton b = new JButton(l.getName());
            b.setActionCommand(l.getName());
            b.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    level = l;
                    setVisible(false);
                }
            });
            panel.add(b);
        }
        add (panel);
        pack();
        setVisible(true);
    }

    public boolean isClosed (){
        return isVisible();
    }

    /**
     * @return the chosen level
     */
    public Level getLevel() {
        return level;
    }

}
