/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Color;
import java.awt.geom.Ellipse2D;

/**
 *
 * @author Fabi
 */
public class Point extends GameObject {

    private Ellipse2D ellipse;
    private static final int WIDTH = 20;
    private static final int HEIGHT = 20;
    private static final int POINTS = 50;
    private static final Color COLOR = Color.GREEN;

    public Point (){
        setShape(ellipse);
        setColor(COLOR);
    }

    public Point(int x, int y) {
        ellipse = new Ellipse2D.Float(x, y, WIDTH, HEIGHT);
        setShape(ellipse);
        setColor(COLOR);
    }

    private final GameObject ME = this;
    @Override
    public void updateObject() {
        GameObject.testCollision(this, new CollisionListener() {

            @Override
            public void onCollision(GameObject o) {
                if (o instanceof Scores) {
                    Scores s = (Scores) o;
                    s.addPoints(POINTS);
                    GameObject.eraseLater(ME);
                }
            }
        });
    }

    @Override
    public void init() {
        setShape(ellipse);
        setColor(COLOR);
    }
}
